/*
  This example shows, that there is an issue with offscreen buffer
  of *double window* not beeing initialised to 0 when it is re-allocated
  during scaling leading to garbage beeing displayed in certain situations.
  (This issue does not arise when using normal window).

  Reproduce: run this program and change scale to 1.5 and back to 1
             a few times.
*/
#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>
#include <FL/fl_draw.H>

//class MyWindow : public Fl_Double_Window
class MyWindow : public Fl_Window // < no problem when using Fl_Window!
{
//typedef Fl_Double_Window Inherited;
typedef Fl_Window Inherited;
public:
	MyWindow( int w_, int h_, const char *l_ = 0 ) :
		Inherited( w_, h_, l_ )
	{
	}
	void draw()
	{
		// Note: this program "naively assumes" it can fill all the screen
		// by drawing lines across the screen for all y positions.
		// (and therefore sees no need to fill the whole screen before)
//		fl_rectf( 0, 0, w(), h(), FL_BLACK ); // < issue can be "hidden" when initialising background
		for ( int y = 0; y < h(); y++ )
		{
			fl_color( y % 2 ? FL_BLACK : FL_WHITE );
			fl_line( 0, y, w(), y );
		}
	}
};

int main( int argc_, char *argv_[] )
{
	MyWindow win( 800, 600 );
	win.end();
	win.show();
	return Fl::run();
}
